
/*
   UPDATER - Update you web pages
   by D.G Sureau - www.scriptol.net

   Use freely this script
   but always provide the scriptol source when you distribute the program

   Principle:
   The program get a part of code enclosed between two tags,
   and copy it into each page holding the same two tags (replacing the
   enclosed part).
   The starting tag may be <!--#START#--> or <!--#START0--> or <!--#START1-->,
   etc... until <!--#STARTz-->
   Any letter may be used as indice, preferably use common ascii 0-9,
   A-Z, a-z...  The default is the # character, thus <!--#START#-->.

   You can replace these tags by ones put in updater.ini.

   You have to put the starting and ending tags, enclosing nothing first,
   when you write a target html page and in the model page.
*/


``    This program is free software; you can redistribute it and/or modify
``    it under the terms of the OSS License.
``    This program is distributed in the hope that it will be useful,
``    but WITHOUT ANY WARRANTY; without even the implied warranty of
``    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
``    GNU General Public License for more details.




include "path.sol"
include "dirlist.sol"
extern array argv
extern int argc

text tagstart ="<!--#START#-->"
text tagend   ="<!--#END#-->"

void usage()
  print
  print "Updater 1.6 - www.scriptol.net"
  print "Replaces a part of code inside a list of files,"
  print "mainly intended to update a menu in all pages of a site."
  print "Usage:"
  print "   updater sourcefile"
  print "   updater sourcefile #n"
  print "or updater sourcefile targetdir  (all htm/html/php files in dir updated)"
  print "or updater sourcefile @targetlist"
  print
  print "The code to replace is recognized according to tagstart and tagend."
  print "A letter may be given as parameter (following #) to select a tagstart."
  print "You have to put the tags into the model and each target document."
  print "Alternate tags may be specified into updater.ini."
  exit(0)
return


void readIni(text inipath)

  array ini
  inipath = Path.changeExt(inipath, "ini")
  if not file_exists(inipath) return
  ini.load(inipath)
  if(ini.size() = 0)
    print inipath, "file not loaded"
    return
  /if

  for text option in ini
    option = option.trim()        ` remove trailing spaces and eol
    if option.length() < 1 continue
    if option[0] = "#" continue
    int i = option.find("=")      ` parse a line
    if i = nil  continue          ` no valid couple key=value
    text k = option[--i].trim()   ` key
    text v = option[i+1..].trim() ` value
    if k
    = "start": tagstart = v
    = "end":   tagend = v
    /if
  /for

return


int findInArray(array a, text t)
   int num = 0
   for text x in a
     if not (x.find(t) = nil) return num
     num + 1
   /for
return -1


`` Main script

if argc not in (2, 3, 4) let usage()

text listname = ""
text listdir = ""
text tagindex = '#'
array targetlist
text sourcefile = argv[1]

if argc = 4
  text temp = argv[2]
  if temp[0] <> '#' let usage()
  tagindex = temp[1]
  temp = argv[3]
  if temp[0] = '@'
     listname = temp[1..]
  else
     listdir = temp
  /if
/if

if argc = 3
  text temp = argv[2]
  if temp[0]
  = '#': tagindex = temp[1]
         listdir = "."
  = "@": listname = temp[1..]
  else listdir = temp
  /if
else
  listdir = "."
/if

readIni("updater.ini")

tagstart[10] = tagindex      ` remain # or get a number


if listname <> nil let targetlist.load(listname)
if listdir <> nil:
   DirList d
   array temp = d.getList(listdir)
   targetlist = ()
   for text t in temp
     text node, ext
     node, ext = Path.splitExt(t)
     if ext in ("htm", "html", "php", "php3", "php4", "php5", "xhtml", "dhtml")
       if listdir <> "." let t = Path.merge(listdir, t)
       if Path.compare(sourcefile, t) continue      ` don't update the model!
       targetlist.push(t)
     /if
   /for
/if

if targetlist = nil let usage()

if not file_exists(sourcefile)
    print sourcefile, "not found"
    exit()
/if


array source
array target

source.load(sourcefile)

if source.size() = 0
  print sourcefile, "source empty"
  exit(0)
/if

int numstt = findInArray(source, tagstart)
int numend = findInArray(source, tagend)
if (numstt = -1) or (numend = -1)
  print "Nothing to update in", sourcefile
  print "these tags are required both in source and targets:"
  print tagstart, "(start of code to copy)"
  print tagend, "(end of code to copy)"
  exit(0)
/if

array replacing = source[numstt .. numend]
int counter = 0

int tarstt, tarend
for text t in targetlist
  t = t.trim()
  if t.length() = 0 continue
  if not file_exists(t)
    print t, "no found"
    continue
  /if
  target.load(t)
  if target.size() = 0
    print t, "target empty"
    continue
  /if
  tarstt = findInArray(target,tagstart)
  tarend = findInArray(target,tagend)
  if (tarstt = -1) or (tarend = -1)
    print "nothing to replace in", t + ", skipped"
    continue
  /if
  target[tarstt .. tarend] = replacing
  target.store(t)
  print t, "updated"
  counter + 1
/for

print counter, "files updated"

